<template>
  <q-page>
    <div class="col-xs-12 col-sm-6 col-md-6 col-lg-6 q-pa-md q-pr-md row justify-center">
      <q-btn v-if="show" size="md" push color="indigo" label="Reporte" @click="report2(typeData,typeValue)" glossy />
        <q-select class="q-px-md" emit-value map-options v-model="typeValue"
          label="Seleccione un Dato" radio :options="typeSelect" option-label="name" option-value="value"
          style="min-width: 320px; max-width: 400px;" @input="getTypes(typeValue)"/>
    </div>
    <div>
      <apexchart v-if="show" type="bar" height="350" :options="chartOptions" :series="series"></apexchart>
    </div>
    <div>
      <div class="col-xs-12 col-sm-6 col-md-6 col-lg-6 q-pa-md q-pr-md row justify-center">
        <q-btn v-if="show2" size="md" push color="indigo" label="Reporte" @click="report(data)" glossy />
        <q-select class="q-px-md" emit-value map-options v-model="regionValue"
          label="Seleccione un Continente" radio :options="regionSelect" option-label="name" option-value="value"
          style="min-width: 320px; max-width: 400px;" @input="getAreas(regionValue)"/>
      </div>
      <apexchart :key="componentKey" v-if="show2" type="pie" :options="chartOptions2" :series="series2"></apexchart>
    </div>
  </q-page>
</template>

<script>
import pdfmake from 'pdfmake'
import * as pdfFonts from 'pdfmake/build/vfs_fonts'
pdfMake.vfs = pdfFonts.pdfMake.vfs
export default {
  data () {
    return {
      componentKey: 0,
      allCountry: [],
      typeData: [],
      typeSelect: [
        { name: 'Continente', value: 'region' },
        { name: 'Idioma', value: 'lang' },
        { name: 'Moneda', value: 'currency' }
      ],
      typeValue: '',
      data: [],
      regionValue: undefined,
      regionSelect: [
        { name: 'Asia', value: 'asia' },
        { name: 'Americas', value: 'americas' },
        { name: 'Africa', value: 'africa' },
        { name: 'Oceania', value: 'oceania' },
        { name: 'Europa', value: 'europe' },
        { name: 'Polar', value: 'polar' },
        { name: 'Sin definir', value: '' }
      ],
      show: false,
      show2: false,
      list_countries: [],
      active_country: [],
      series: [
        {
          name: 'Paises',
          data: []
        }
      ],
      chartOptions: {
        annotations: {
          points: [{
            x: 'Bananas',
            seriesIndex: 0,
            label: {
              borderColor: '#775DD0',
              offsetY: 0,
              style: {
                color: '#fff',
                background: '#775DD0'
              },
              text: 'Bananas are good'
            }
          }]
        },
        chart: {
          height: 350,
          type: 'bar'
        },
        plotOptions: {
          bar: {
            columnWidth: '50%',
            endingShape: 'rounded'
          }
        },
        dataLabels: {
          enabled: true
        },
        stroke: {
          width: 2
        },

        grid: {
          row: {
            colors: ['#fff', '#f2f2f2']
          }
        },
        xaxis: {
          labels: {
            rotate: -45
          },
          categories: [],
          tickPlacement: 'on'
        },
        yaxis: {
          title: {
            text: 'Total Paises'
          }
        },
        fill: {
          type: 'gradient',
          gradient: {
            shade: 'light',
            type: 'horizontal',
            shadeIntensity: 0.25,
            gradientToColors: undefined,
            inverseColors: true,
            opacityFrom: 0.85,
            opacityTo: 0.85,
            stops: [50, 0, 100]
          }
        }
      },
      series2: [],
      chartOptions2: {
        title: {
          text: 'Areas de Paises por Continente',
          align: 'left',
          margin: 10,
          offsetX: 0,
          offsetY: 0,
          floating: false,
          style: {
            fontSize: '14px',
            fontWeight: 'bold',
            fontFamily: undefined,
            color: '#263238'
          }
        },
        chart: {
          width: '380',
          type: 'pie'
        },
        labels: [],
        responsive: [{
          breakpoint: 480,
          options: {
            chart: {
              width: 200
            },
            legend: {
              position: 'bottom'
            }
          }
        }]
      }
    }
  },
  async mounted () {
    await this.$api.get('https://restcountries.eu/rest/v2/all?fields=region;name;capital;currencies;languages').then(res => {
      this.allCountry = res
    }).catch(error => {
      console.log(error)
    })
  },
  methods: {
    async getAreas (val) {
      this.data = []
      this.chartOptions2.labels = []
      this.series2 = []
      let route = ''
      if (val === '') {
        route = 'https://restcountries.eu/rest/v2/name/antarctica?fields=name;area;capital;currencies;languages'
      } else {
        route = `https://restcountries.eu/rest/v2/region/${val}?fields=name;area;capital;currencies;languages`
      }
      await this.$api.get(route).then(res => {
        console.log(res)
        for (const i of res) {
          if (i.area !== undefined) {
            this.data.push(i)
            this.chartOptions2.labels.push(i.name)
            this.series2.push(i.area)
          }
        }
        this.show2 = true
        this.componentKey++
      }).catch(error => {
        console.log(error)
      })
    },
    async getTypes (val) {
      val === 'lang' ? val = 'languages' : val === 'currency' ? val = 'currencies' : val = 'region'
      console.log(val)
      this.series[0].data = []
      this.typeData = []
      var resType = this.allCountry.map(ele => {
        if (typeof ele[val] !== 'string') {
          for (const i of ele[val]) {
            return i.name
          }
        } else {
          return ele[val]
        }
      })
      var filterTypes = resType.filter((item, index) => { return resType.indexOf(item) === index })
      filterTypes.sort()
      console.log(filterTypes)
      var sortTypes = []
      for (const i in filterTypes) {
        let count = 0
        var filterR = this.allCountry
        this.series[0].data.push(filterR.filter(ele => {
          if (typeof ele[val] !== 'string') {
            for (const j of ele[val]) {
              if (j.name === filterTypes[i]) return count++
            }
          } else {
            if (ele[val] === filterTypes[i]) return count++
          }
        }).length)
        sortTypes[i] = { name: filterTypes[i], count: count }
      }
      if (val !== 'region') {
        this.series[0].data = sortTypes.filter(ele => ele.count > 5).map(ele => ele.count)
        sortTypes = sortTypes.filter(ele => ele.count > 5).map(ele => ele.name)
      } else {
        this.series[0].data = sortTypes.map(ele => ele.count)
        sortTypes[0].name = 'Sin Categoria'
        sortTypes = sortTypes.map(ele => ele.name)
      }
      for (const i in sortTypes) {
        this.typeData[i] = { name: sortTypes[i], count: this.series[0].data[i] }
      }
      console.log(this.typeData, 'tipo de datos')
      this.chartOptions = {
        ...this.chartOptions,
        ...{
          xaxis: {
            categories: sortTypes
          }
        }
      }
      this.show = true
    },
    selectImg (val) {
      console.log(val)
    },
    report (allData) {
      var dd = {
        pageMargins: [80, 60, 40, 40],
        content: [
          {
            alignment: 'center',
            bold: true,
            text: 'Lista de Paises del Mundo'
          },
          '\n',
          'Encontraremos su capital y la moneda que tienen en circulación.',
          '\n',
          {
            style: 'tableExample',
            table: {
              headerRows: 1,
              body: [
                [
                  { text: 'País', style: 'tableHeader' },
                  { text: 'Capital', style: 'tableHeader' },
                  { text: 'Moneda', style: 'tableHeader' },
                  { text: 'Simbolo', style: 'tableHeader' }
                ]
              ]
            },
            layout: 'lightHorizontalLines'
          }
        ]
      }
      console.log(allData)
      for (var x in allData) {
        dd.content[4].table.body.push([
          allData[x].name,
          allData[x].capital ? allData[x].capital : 'n/a',
          allData[x].currencies[0].name ? allData[x].currencies[0].name : 'n/a',
          allData[x].currencies[0].symbol ? allData[x].currencies[0].symbol : 'n/a'
        ])
      }
      pdfMake.createPdf(dd).download()
    },
    report2 (allData, val) {
      console.log(this.chartOptions.xaxis.categories)
      var dd = {
        pageMargins: [80, 60, 40, 40],
        content: [
          {
            alignment: 'center',
            bold: true,
            text: 'Paises '
          },
          '\n',
          'Lista de Paises con mas de 5 ' + this.typeSelect.find(ele => ele.value === val).name,
          '\n',
          {
            style: 'tableExample',
            table: {
              headerRows: 1,
              body: [
                [
                  { text: this.typeSelect.find(ele => ele.value === val).name, style: 'tableHeader' },
                  { text: 'Cantidad', style: 'tableHeader' }
                ]
              ]
            },
            layout: 'lightHorizontalLines'
          }
        ]
      }
      console.log(allData)
      for (var x in allData) {
        dd.content[4].table.body.push([
          allData[x].name,
          allData[x].count
        ])
      }
      pdfMake.createPdf(dd).download()
    }
  }
}
</script>

<style>

</style>
